import numpy as np
import matplotlib.pyplot as plt
import os.path
import glob, os

ipath="./data/"

def READFILE(filenamesig):
	Angle=[];
	Signal=[];
	ErrorSig=[];
	key_val={};
	fid=open(filenamesig,'r');
	for line in fid:
		if (line[0]=='#'):
			entries=line.replace('#','').replace('-','').replace(' ','').replace('_','').replace('\n','').split('=')
			key_val[entries[0]]=entries[1]
		else:
			data=line.replace('\n','').split('\t');
			if (data[0]!=''):
				Angle.append(float(data[0]));
				Signal.append(float(data[1]));
				ErrorSig.append(float(data[2]));
	fid.close()
	#print float(key_val['electronsig'])
	return Angle, Signal, ErrorSig, key_val;
	

#Angle, Signal, ErrorSig, key_val=READFILE('./data/20170502/data_CLIO_2017-05-02_10-18-37.sig')
#print Angle, Signal, ErrorSig, key_val
def takedata(idate,iniTime,finTime):
	position=[];
	Amplitude=[];
	SigErr=[];
	date=[];
	Electron_sig=[];
	Electron_sig_std=[];
	Angle=[];
	current=[];
	for file in glob.glob(ipath+idate+"/*.sig"):
		#print(file)
		Angle_val, Signal, ErrorSig, key_val=READFILE(file)
		thistime=int(key_val['date'])-int(idate)*1e+6
		if ((thistime>iniTime)&(thistime<finTime)):
			position.append(float(key_val['motorvalue']))
			Electron_sig.append(float(key_val['electronsig']))
			Electron_sig_std.append(float(key_val['electronstd']))
			Amplitude.append(Signal)
			Angle.append(Angle_val)
			SigErr.append(ErrorSig)
			date.append(thistime)
			current.append(float(key_val['currentvalue']))
	return position,current,Angle, Amplitude,SigErr,date,Electron_sig,Electron_sig_std;


#position,current,Angle, Amplitude,SigErr,date,Electron_sig,Electron_sig_std=takedata('20170524',0,235959)
#print date
#print  Amplitude[1][:]
#print  [row[1] for row in Amplitude]
#plt.plot(position, [row[4] for row in Amplitude],'o')
#plt.plot(position, [row[7] for row in Amplitude],'o')
#plt.plot(position, [row[10] for row in Amplitude],'o')
#plt.ylabel('some numbers')
#plt.show()
