
from Tkinter import *
from ttk import *

import matplotlib
matplotlib.use("TkAgg")
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2TkAgg
from matplotlib.figure import Figure
from analysis import *
import matplotlib.animation as animation
from matplotlib import style
style.use('ggplot')
import numpy as np
import tkMessageBox as mbox
import os

path='./data/'
lowlim=103000
highlim=110000
Pause=1000
dateYMD='20170524'
PositionDet=4000000;
detN=[4,7,10]
minElecSignal=1000
canvas2=0
canvas3=0
x0=5
Energy=44
RefP=False
ClearP=False
dateP=0;
fig0 = Figure(figsize=(5,4), dpi=100)
a0 = fig0.add_subplot(111)

fig1 = Figure(figsize=(5,4), dpi=100)
a1 = fig1.add_subplot(111)

fig3 = Figure(figsize=(5,4), dpi=100)
a3 = fig3.add_subplot(111)

def position_plot(i):
	a0.clear()
	position,current,tmp, Amplitude,SigErr,date,Electron_sig,Electron_sig_std=takedata(dateYMD,lowlim,highlim)

	#check on correct values
	detX=[]
	for c in range(0,len(detN)):
		if (detN[c]>0)&(detN[c]<13):
			detX.append(detN[c])

	for detectorN in detX:
		positionCUT=[]
		AmplitudeCUT=[]
		AmpDet=[row[detectorN-1] for row in Amplitude];
		for c in range(1,len(date)):
			if (date[c]>lowlim)&(date[c]<highlim)&(Electron_sig[c]>minElecSignal)&(AmpDet[c]>0):
				positionCUT.append(position[c]/1.e+6)
				AmplitudeCUT.append(AmpDet[c]/Electron_sig[c])
		a0.plot(positionCUT, AmplitudeCUT,'^', label="Detector #"+str(detectorN))
	a0.set_ylim(ymax=0.04, ymin=0.)
	a0.legend()
	a0.set_xlabel('Position, [Msteps]')
	#print 'hello2'
#def spectrum_plot(k):
	#position,current,tmp, Amplitude,SigErr,date,Electron_sig,Electron_sig_std=takedata(dateYMD,lowlim,highlim)
	Angle=[48, 55, 62, 69, 76, 83, 90, 97, 104, 111, 118, 125]
	AmplitudeCUT=[]
	AmplitudeCUT2=[]
	positionCUT=[]
	dateCUT=[]
	dateCUT2=[]
	for c in range(1,len(date)):
		if (date[c]>lowlim)&(date[c]<highlim)&(Electron_sig[c]>minElecSignal):
			AmplitudeCUT.append([x/Electron_sig[c] for x in Amplitude[c]])
			positionCUT.append(position[c])
			dateCUT.append(date[c])
	#find nearest position to requested
	imin=1e+6
	indx=0
	for c in range(0,len(positionCUT)):
		if abs(positionCUT[c]-np.asarray(PositionDet))<=imin:
			indx=c
			imin=abs(positionCUT[c]-np.asarray(PositionDet))
	#mbox.showinfo("Information", "Spectrum for position "+str(positionCUT[indx])+"is shown of figure")
	for c in range(0,len(positionCUT)):
		if positionCUT[c]==positionCUT[indx]:
			AmplitudeCUT2.append(AmplitudeCUT[c])
			dateCUT2.append(dateCUT[c])
	Spectrum=[0,0,0,0,0,0,0,0,0,0,0,0]
	indx2=0
	global ClearP
	if ClearP:
		a1.clear()
		a3.clear()
		canvas2.show()
		canvas3.show()
		ClearP=False	
	if (dateCUT2):
		indx2=np.argmax(dateCUT2)
		global RefP
		if not RefP:
			a1.clear()
			a3.clear()
		global dateP
		if not dateP==dateCUT2[indx2]:
		#a1.plot(Angle, np.mean(AmplitudeCUT2,axis=0),'-^')#mean!!!
			a1.plot(Angle, AmplitudeCUT2[indx2],'-^')
			a1.set_title("Position "+str(positionCUT[indx]))
			a1.set_ylim(ymax=0.04, ymin=0.)
			a1.set_xlabel('Angle, [deg.]')
			dateP=dateCUT2[indx2]
			canvas2.show()
			Spectrum=AmplitudeCUT2[np.argmax(dateCUT2)]
	#def animate3():
		#position,current,tmp, Amplitude,SigErr,date,Electron_sig,Electron_sig_std=takedata(dateYMD,lowlim,highlim)
		#Angle=[48, 55, 62, 69, 76, 83, 90, 97, 104, 111, 118, 125]
		#detectorN=7
		#positionCUT=[]
		#	AmplitudeCUT=[]
		#AmpDet=[row[detectorN] for row in Amplitude];
		#for c in range(1,len(date)):
			#if (date[c]>lowlim)&(date[c]<highlim)&(Electron_sig[c]>minElecSignal):
				#AmplitudeCUT.append(Amplitude[c])


			pullData = open('./SEY/CLIO_'+str(Energy)+'MeV_x0'+str(x0)+'mm.txt','r').read()
			dataArray = pullData.split('\n')
			x=[]
			for eachLine in dataArray:
				if len(eachLine)>1:
					x.append([float(s) for s in eachLine.split() ])
			Thet=[row[0] for row in x]
			SEY=[row[1] for row in x]
			FF=range(0,len(Angle))
			Freq=range(0,len(Angle))
	
			for cntA in range(0,len(Angle)):
				for cntT in range(0,len(Thet)):
					if Angle[cntA]==Thet[cntT]:
						FF[cntA]=Spectrum[cntA]/SEY[cntT]*1.6e-19
						Freq[cntA]=0.5e+11/(1.-np.cos(Angle[cntA]/180.*3.1415926536))*1e-12
	
			
			a3.plot(Freq, FF,'-^')
			a3.set_title('Energy='+str(Energy)+'MeV; x0='+str(x0)+'mm')
			a3.set_xlabel('Frequency, [THz]')
			a3.set_ylim( ymin=0.,ymax=0.02)
			canvas3.show()

class Example(Frame):
  
    def __init__(self, parent):
        Frame.__init__(self, parent)   
         
        self.parent = parent
        self.initUI()
	
        
    def initUI(self):
      
		self.parent.title("Spectrum analyzing tool | ETALON")
		self.style = Style()
		self.style.theme_use("default")
		self.pack(fill=BOTH, expand=True)

  
		menubar = Menu(self.parent)
		self.parent.config(menu=menubar)
        
		fileMenu = Menu(menubar)
		fileMenu.add_command(label="Pause", state=DISABLED)
		fileMenu.add_command(label="Open", state=DISABLED)
		fileMenu.add_command(label="Options", state=DISABLED)
		fileMenu.add_command(label="Exit", command=self.quit)

		aboutMenu = Menu(menubar)
		aboutMenu.add_command(label="Tutorial", command=DISABLED)
		aboutMenu.add_command(label="Info", command=self.about)

		menubar.add_cascade(label="Control", menu=fileMenu)
		menubar.add_cascade(label="About", menu=aboutMenu)

		stepZero = LabelFrame(self, text="Position:")
		stepZero.grid(row=0, columnspan=6, sticky='WE', padx=5, pady=5, ipadx=5, ipady=5)
		canvas1 = FigureCanvasTkAgg(fig0, stepZero)
		canvas1.show()
		canvas1.get_tk_widget().pack(padx=5,pady=10)
		Label(stepZero, text="Detector:").pack(side=LEFT, padx=5, pady=8)
		self.Detnum = Entry(stepZero)
		self.Detnum.pack(side=LEFT, padx=5, pady=8)
		self.Detnum.insert(1,'4, 7, 10')
		Button(stepZero, text="Update", command=self.SetDetector).pack(side=RIGHT, padx=5, pady=8)

		stepZero2 = LabelFrame(self, text="Spectrum:")
		stepZero2.grid(row=0,column=7, columnspan=6, sticky='WE', padx=5, pady=5, ipadx=5, ipady=5)
		global canvas2
		canvas2 = FigureCanvasTkAgg(fig1, stepZero2)
		
		canvas2.show()
		canvas2.get_tk_widget().pack(padx=5,pady=10)
		#toolbar = NavigationToolbar2TkAgg(self.canvas2, stepZero2)
		#toolbar.update()
		#canvas._tkcanvas.pack(side=TOP, fill=BOTH, expand=True)
		Label(stepZero2, text="Postion:").pack(side=LEFT, padx=5, pady=8)
		self.Posnum = Entry(stepZero2)
		self.Posnum.pack(side=LEFT, padx=5, pady=8)
		self.Posnum.insert(1,'4000000')
		Button(stepZero2, text="Clear", command=self.SetClear).pack(side=RIGHT, padx=5, pady=8)
		Checkbutton(stepZero2, text="Set Reference", command=self.SetReference).pack(side=RIGHT, padx=5, pady=8)
		#Button(stepZero2, text="Set Ref", command=self.SetReference).pack(side=RIGHT, padx=5, pady=8)
		Button(stepZero2, text="Update", command=self.SetPosition).pack(side=LEFT, padx=5, pady=8)
		stepZero3 = LabelFrame(self, text="Form Factor:")
		stepZero3.grid(row=0,column=13, columnspan=6, sticky='WE', padx=5, pady=5, ipadx=5, ipady=5)
		global canvas3
		canvas3 = FigureCanvasTkAgg(fig3, stepZero3)
		#animate3()
		canvas3.show()
		canvas3.get_tk_widget().pack(padx=5,pady=10)
		Label(stepZero3, text="Energy (MeV):").pack(side=LEFT, padx=5, pady=8)
		#self.inFileTxt = Entry(stepZero3)
		#self.inFileTxt.pack(side=LEFT, padx=5, pady=8)
		#self.inFileTxt.insert(1,'44.3')
		Eng=[]
		for c in range(34,45):
			Eng.append(str(c))
		self.box = Combobox(stepZero3, value=Eng)
		self.box.bind("<<ComboboxSelected>>", self.newselection)
		self.box.current(10)
		self.box.pack(side=LEFT, padx=5, pady=8)
		Label(stepZero3, text="BGS (mm):").pack(side=LEFT, padx=5, pady=8)
		posX=[]
		for c in range(0,30,5):
			posX.append(str(c))
		self.box2 = Combobox(stepZero3, value=posX)
		self.box2.bind("<<ComboboxSelected>>", self.newselection2)
		self.box2.current(1)
		self.box2.pack(side=LEFT, padx=5, pady=8)



		#Button(stepZero3, text="Ok", state=DISABLED).pack(side=RIGHT, padx=5, pady=8)



		stepOne = LabelFrame(self, text="Date/Time settings: ")
		stepOne.grid(row=1, columnspan=6, sticky='WE', padx=5, pady=5, ipadx=5, ipady=5)


		Label(stepOne, text="Start:").grid(row=0, column=0, sticky='E', padx=5, pady=2)

		self.inFileTxt = Entry(stepOne)
		self.inFileTxt.grid(row=0, column=1,  sticky="WE", pady=3)
		self.inFileTxt.insert(1,str(lowlim))
		Label(stepOne, text='      ').grid(row=0, column=2, sticky='E', padx=5, pady=2)
		Label(stepOne, text="End:").grid(row=0, column=3, sticky='E', padx=5, pady=2)

		self.outFileTxt = Entry(stepOne)
		self.outFileTxt.grid(row=0, column=4,  sticky="WE", pady=2)
		self.outFileTxt.insert(2,str(highlim))
		outFileBtn = Label(stepOne, text='      ')
		outFileBtn.grid(row=0, column=5, sticky='E', padx=5, pady=2)

		Label(stepOne, text="Data").grid(row=1, column=0, sticky='E', padx=5, pady=2)
		self.inEncTxt = Entry(stepOne)
		self.inEncTxt.grid(row=1, column=1, sticky='E', pady=2)
		self.inEncTxt.insert(3,str(dateYMD))
		Label(stepOne, text='      ').grid(row=1, column=2, sticky='E', padx=5, pady=2)

		#Label(stepOne, text="Detector").grid(row=1, column=3, sticky='E', padx=5, pady=2)
		#self.outEncTxt = Entry(stepOne)
		#self.outEncTxt.grid(row=1, column=4, sticky='E', pady=2)
		#self.outEncTxt.insert(3,'7')		

		outEncLbl = Button(stepOne, text="Set", command=self.on_button)
		outEncLbl.grid(row=1, column=5, padx=5, pady=2)


    def SetDetector(self):
		global detN
		detN=[int(x) for x in self.Detnum.get().split(',') if x.strip().isdigit()]
		#print detN
    def SetClear(self):
    	global ClearP
    	ClearP=True

    def SetReference(self):
    	global RefP
    	if (RefP==True):
    		RefP=False
    	else:
    		RefP=True

    def SetPosition(self):
		global PositionDet
		PositionDet=[int(x) for x in self.Posnum.get().split(',') if x.strip().isdigit()]
    def newselection(self, event):
    	global Energy
        Energy=int(self.box.get())
    def newselection2(self, event):
    	global x0
        x0=(int(self.box2.get()))
    def about(self):
    	pullData = open('Info.txt','r').read()
    	mbox.showinfo("Information", pullData)

    def on_button(self):
		global lowlim
		lowlim=int(self.inFileTxt.get())
		global highlim
		highlim=int(self.outFileTxt.get())
		global dateYMD
		dateYMD=self.inEncTxt.get()
		if len(dateYMD)>8:
			mbox.showerror("Error", "Wrong date type! It should be YYYYMMDD, example 20170504")
		if (not (os.path.isdir(path+dateYMD+'/'))):
			mbox.showerror("Error", "This day with measurements is not exist!!! Chack the date!")					 





def main():
  
	root = Tk()
	root.geometry("1630x600+300+300")
	app = Example(root)
	ani = animation.FuncAnimation(fig0,position_plot, interval=1000)
	root.mainloop()  


if __name__ == '__main__':
    main()  
